// Manage functions for the functional area "ToDo"
var toDoConfig = {
  maskId : 60,
  statusId: 1,
  prioId: 9,
  escalationStatus: "Eskalation"
};

function onBeforeCheckinSord(ec, sord, sordDB, parentSord, sordZ, unlockZ) {
  if ((sord.mask == toDoConfig.maskId) && parentSord) {
    updateIndexing(sord, parentSord);
  }
}

function onAfterRefSord(ec, parentSordOld, parentSordNew, sord, index) {
  if (sord.mask == toDoConfig.maskId) {
    var editInfo = ix.checkoutSord(ec.ci, sord.id, CONST.EDIT_INFO.mbSord, CONST.LOCK.YES);
    updateIndexing(editInfo.sord, parentSordNew);
    ix.checkinSord(ec.ci, editInfo.sord, CONST.SORD.mbLean, CONST.LOCK.YES);   }
}

function updateIndexing(sord, parentSord) {
  if (sord.mask == toDoConfig.maskId) {
    var status = parentSord.name;
    var objKeys = sord.objKeys;
    
    // Change the status automatically
    objKeys[toDoConfig.statusId].data = [status];
    
    // Save the priority change
    if ((status.indexOf("Prio ") == 0) && (status.length() > 5)) {
      var actPrio = objKeys[toDoConfig.prioId].data;
      if ((actPrio.length == 0) || (actPrio[0] != toDoConfig.escalationStatus)) {
        log.info("TODO: " + sord.id + " - set new prio to: " + status.substring(5));
        objKeys[toDoConfig.prioId].data = [ status.substring(5) ];
      }
    }
  }
}